<script setup>
defineEmits(['close']);

const props = defineProps({
  links: { type: Array, required: true },
});

const localePath = useLocalePath();
const activeMenu = ref(null);

const toggleActive = (id) => {
  activeMenu.value = activeMenu.value === id ? null : id;
};
</script>

<template>
  <div
    class="absolute inset-0 z-10 py-5 bg-white lg:hidden dark:bg-las-d-brown"
  >
    <div class="container px-4 mx-auto mb-4">
      <a
        class="block mb-4"
        href="#"
        aria-label="Close menu"
        @click.prevent="() => $emit('close')"
      >
        <IconsClose
          class="text-las-orange ml-auto hover:opacity-75 dark:text-las-d-orange"
        />
      </a>

      <ul class="flex flex-col">
        <li v-for="link in props.links" :key="link.name">
          <NuxtLink
            v-if="!!link.to"
            :to="localePath(link.to)"
            class="flex items-center py-2 px-4 shadow-lg uppercase rounded-lg hover:opacity-75 dark:bg-las-d-prune"
            >{{ link.name }}</NuxtLink
          >

          <div v-if="!!link.dropdown" class="flex flex-col mb-4">
            <a
              href="#"
              :class="[
                'flex',
                'items-center',
                'py-2',
                'px-4',
                'shadow-lg',
                'uppercase',
                'rounded-t-lg',
                { 'rounded-b-lg': activeMenu !== link.dropdown.id },
                'hover:opacity-75',
                'dark:bg-las-d-prune',
              ]"
              @click.prevent="() => toggleActive(link.dropdown.id)"
            >
              <IconsArrow
                :class="[
                  link.dropdown.iconClass,
                  'mr-2',
                  'shrink-0',
                  { '-rotate-90': activeMenu !== link.dropdown.id },
                ]"
              />

              {{ link.name }}
            </a>

            <Transition
              enter-active-class="duration-200 ease-in"
              enter-from-class="transform opacity-0 -translate-y-6"
              enter-to-class="opacity-100 translate-y-0"
              leave-active-class="duration-200 ease-out"
              leave-from-class="opacity-100 translate-y-0"
              leave-to-class="transform opacity-0 -translate-y-6"
            >
              <ul
                v-show="activeMenu === link.dropdown.id"
                class="flex flex-col"
                :class="[link.dropdown.bgClass, 'rounded-b-lg', 'shadow-lg']"
              >
                <li v-for="sublink in link.dropdown.links" :key="sublink.name">
                  <NuxtLink
                    :to="sublink.to"
                    :class="[
                      'block',
                      'p-4',
                      'text-white',
                      'hover:bg-white',
                      'hover:bg-opacity-25',
                      'focus:bg-white',
                      'focus:bg-opacity-30',
                      'active:bg-opacity-40',
                    ]"
                  >
                    {{ sublink.name }}
                  </NuxtLink>
                </li>
              </ul>
            </Transition>
          </div>
        </li>
      </ul>
    </div>
  </div>
</template>
